﻿// FWSoundMixer 1.1
// ----------------
// This demo shows how to simply mix a track loaded dynamically (from an URL), a sound from library and mix them together.
// Use mySoundMixer.startCapture(true); to enable microphone recording as well.

// The resulting mix is saves as WAV file.

package  {	

	// comment these 3 out for Flash Player compilation. AIR freaks out when these are put into 
	// compiler constants, thinking there's no ActionScript code at all (bug?)
		import flash.filesystem.File;
		import flash.filesystem.FileStream;
		import flash.filesystem.FileMode;

	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;	
	import flash.net.URLRequest;
	import flash.utils.ByteArray;
	import flash.display.Graphics;

	import com.rainbowcreatures.swf.*;
	import com.rainbowcreatures.*;
	
	import flash.net.FileReference;
	import flash.events.StatusEvent;
	import flash.media.SoundChannel;
	
	public class Document extends MovieClip {
		
		// our FW SoundMixer sound classes
		var beep:FWSound;
		var track:FWSound;		
		
		// the FW SoundMixer
		var mySoundMixer:FWSoundMixer;

		// which frame are we at?
		var frameIndex:Number = 0;
		
		// sound channel
		var myChannel:SoundChannel = new SoundChannel();

		public function Document() {
			// init the FW SoundMixer
			addChild(new FPSCounter());
			mySoundMixer = FWSoundMixer.getInstance();
			mySoundMixer.addEventListener(StatusEvent.STATUS, onStatus);
			mySoundMixer.load("../../lib/FlashPlayer/");
		}
		
		function onStatus(e:StatusEvent):void {
			if (e.code == 'ready') {
				// init the sound mixer, with internal WAV recording switched on and sounds playing from buffer for preview
				// - that means we will also hear the microphone
				mySoundMixer.recordWAV = true;			
//				mySoundMixer.playSounds = true;			
				mySoundMixer.init();
				
				startButton.enabled = true;
				soundButton.addEventListener(MouseEvent.CLICK, onSoundButtonClick);
				saveButton.addEventListener(MouseEvent.CLICK, onSaveButtonClick);
				startButton.addEventListener(MouseEvent.CLICK, onStartButtonClick);				

				// init the sounds, notice the third parameter is the Flash Sound which our class encapsulates				
				beep = new FWSound(null, null, new beepSound(), mySoundMixer, true);
								
				track = new FWSound(null, null, null, mySoundMixer, true);
				track.addEventListener(Event.COMPLETE, onComplete);							
				track.load(new URLRequest("piano.mp3"));				
			}
		}

		// this is adaptation of Adobe's SoundMixer waveform generation example for FWSoundMixer
		function onFrame(e:Event):void {
			// don't do it every frame, its already too slow
			if (frameIndex % 3 == 0) {
			var bytes:ByteArray = mySoundMixer.rawData;
            const PLOT_HEIGHT:int = 200;
			// this will show only part of the actual rawData, but its enough
            const CHANNEL_LENGTH:int = 276;
            var g:Graphics = this.graphics;
            
            g.clear();
       
            g.lineStyle(0, 0xCC0066);
            g.beginFill(0xCC0066);
            g.moveTo(0, PLOT_HEIGHT);
            
            var n:Number = 0;
            bytes.position = 0;
			
			// display just left channel for simplicity
            for (var i:int = 0; i < CHANNEL_LENGTH; i += 2) {
				bytes.position = i * 4;				
                n = (bytes.readFloat() * 100);
                g.lineTo(i * 2, PLOT_HEIGHT - n);				
            }

            g.lineTo(CHANNEL_LENGTH * 2, PLOT_HEIGHT);
            g.endFill(); 
			}
			frameIndex++;
		}
		
		function onComplete(e:Event):void {			
			startButton.enabled = true;
		}		

		function onStartButtonClick(e:MouseEvent):void {						
			myChannel = track.play(0, 100);
			
			saveButton.enabled = true;
			soundButton.enabled = true;
			startButton.enabled = false;
			
			// don't forget to call startCapture when everything is setup
	       	mySoundMixer.startCapture(false);			
			addEventListener(Event.ENTER_FRAME, onFrame);						
		}

		function onSaveButtonClick(e:MouseEvent):void {
			// stop capturing

			mySoundMixer.stopCapture();
			myChannel.stop();
			removeEventListener(Event.ENTER_FRAME, onFrame);									
			
			// set buttons and save the captured audio to wav file
			saveButton.enabled = false;
			soundButton.enabled = false;
			startButton.enabled = true;
			
			if (CONFIG::AIR) {
				trace("Saving WAV file...");
				var file:File;
				// save to apps folder on iOS (even it's not really needed, there will always be a file called "video_merged.mp4")
 				file = File.userDirectory.resolvePath("audio.wav");						
 				var fileStream:FileStream = new FileStream();
				fileStream.open(file, FileMode.WRITE);
				trace("Saving " + mySoundMixer.WAV.length + " bytes ...");
   				fileStream.writeBytes(mySoundMixer.WAV, 0, mySoundMixer.WAV.length);
   				fileStream.close();
				trace("Done, file was saved to " + file.nativePath);
			}
			
			if (CONFIG::FLASH) {
				var f:FileReference = new FileReference();
				f.save(mySoundMixer.WAV, "audio.wav");			
			}
			
			// we must delete the WAV data manually for now after saving, or it will accumulate in memory!			
			mySoundMixer.WAV.length = 0;
		}
		
		function onSoundButtonClick(e:MouseEvent):void {
			beep.play();
		}
	}
}