﻿/**
 *
 * Hungry Hero Game
 * http://www.hungryherogame.com
 * 
 * Copyright (c) 2012 Hemanth Sharma (www.hsharma.com). All rights reserved.
 * 
 * This ActionScript source code is free.
 * You can redistribute and/or modify it in accordance with the
 * terms of the accompanying Simplified BSD License Agreement.
 *  
 */

package 
{
	import flash.media.Sound;	
	import com.rainbowcreatures.*;
	import com.rainbowcreatures.swf.*;

	/**
	 * This class holds all the sound embeds and objects that are used in the game. 
	 * 
	 * @author hsharma
	 * 
	 */
	public class Sounds
	{
		/**
		 * Embedded sound files. 
		 */		
		[Embed(source="../media/sounds/bgGame.mp3")]
		public static const SND_BG_GAME:Class;
		
		[Embed(source="../media/sounds/bgWelcome.mp3")]
		public static const SND_BG_MAIN:Class;
		
		[Embed(source="../media/sounds/eat.mp3")]
		public static const SND_EAT:Class;
		
		[Embed(source="../media/sounds/coffee.mp3")]
		public static const SND_COFFEE:Class;
		
		[Embed(source="../media/sounds/mushroom.mp3")]
		public static const SND_MUSHROOM:Class;
		
		[Embed(source="../media/sounds/hit.mp3")]
		public static const SND_HIT:Class;
		
		[Embed(source="../media/sounds/hurt.mp3")]
		public static const SND_HURT:Class;
		
		[Embed(source="../media/sounds/lose.mp3")]
		public static const SND_LOSE:Class;
		
		/**
		 * Initialized Sound objects. 
		 */		
		public static var sndBgMain:FWSound;
		public static var sndBgGame:FWSound;
		public static var sndEat:FWSound;
		public static var sndCoffee:FWSound;
		public static var sndMushroom:FWSound;
		public static var sndHit:FWSound;
		public static var sndHurt:FWSound;
		public static var sndLose:FWSound;

		// FWSoundMixer - these were the original declarations

/*		public static var sndBgMain:Sound = new Sounds.SND_BG_MAIN() as Sound;
		public static var sndBgGame:Sound = new Sounds.SND_BG_GAME() as Sound;
		public static var sndEat:Sound = new Sounds.SND_EAT() as Sound;
		public static var sndCoffee:Sound = new Sounds.SND_COFFEE() as Sound;
		public static var sndMushroom:Sound = new Sounds.SND_MUSHROOM() as Sound;
		public static var sndHit:Sound = new Sounds.SND_HIT() as Sound;
		public static var sndHurt:Sound = new Sounds.SND_HURT() as Sound;
		public static var sndLose:Sound = new Sounds.SND_LOSE() as Sound;*/

		/**
		 * Sound mute status. 
		 */
		public static var muted:Boolean = false;
		
		public static function init():void {

			// FWSoundMixer - to record all playing sounds of this game we need encapsulate them in FWSound class
			//                HungryHero also uses SoundMixer.stopAll() - for stopping sounds we need to use 
			//                FWSoundMixer.stopAll() instead.

			sndBgMain = new FWSound(null, null, new Sounds.SND_BG_MAIN() as Sound, FWSoundMixer.getInstance());
			sndBgGame = new FWSound(null, null, new Sounds.SND_BG_GAME() as Sound, FWSoundMixer.getInstance());
			sndEat = new FWSound(null, null, new Sounds.SND_EAT() as Sound, FWSoundMixer.getInstance());
			sndCoffee = new FWSound(null, null, new Sounds.SND_COFFEE() as Sound, FWSoundMixer.getInstance());
			sndMushroom = new FWSound(null, null, new Sounds.SND_MUSHROOM() as Sound, FWSoundMixer.getInstance());
			sndHit = new FWSound(null, null, new Sounds.SND_HIT() as Sound, FWSoundMixer.getInstance());
			sndHurt = new FWSound(null, null, new Sounds.SND_HURT() as Sound, FWSoundMixer.getInstance());
			sndLose = new FWSound(null, null, new Sounds.SND_LOSE() as Sound, FWSoundMixer.getInstance());
		}		
	}
}